﻿//////////////////////////////////////////////
// DecodedMeshData.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkGraphics
#include "../../Dll/DllDefines.h"

#include "../../Meshes/Enums/IndexFormat.h"

#include "../../Meshes/InputLayouts/MeshInputLayout.h"

// nkMemory
#include <NilkinsMemory/Containers/Buffer.h>
#include <NilkinsMemory/Containers/BufferCast.h>

/// Class ------------------------------------

namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT DecodedMeshData
	{
		public :

			// Attributes
			nkMemory::BufferCast<nkMemory::Buffer> _vertexBuffers ;
			nkMemory::Buffer _indexBuffer ;

			MeshInputLayout _inputLayout ;

			unsigned int _vertexCount ;
			unsigned int _indexCount ;

			INDEX_FORMAT _indexFormat ;

		public :

			// Constructor, destructor
			DecodedMeshData () ;
			~DecodedMeshData () ;
	} ;
}