﻿//////////////////////////////////////////////
// ProfilingHelper.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkGraphics
#include "ProfilingInfosHolder.h"

#include "../Dll/DllDefines.h"

/// Class ------------------------------------
	
namespace nkGraphics
{
	// Le callback qu'il est possible de soumettre
	typedef void (*gpuAnswerCallback) (ProfilingInfosHolder* profilingInfos) ;

	class DLL_GRAPHICS_EXPORT ProfilingHelper
	{
		protected :

			// Attributs
			// Témoins de ce qu'on veut track
			bool _gpuTimeTracked ;
			bool _cpuTimeTracked ;
			bool _statsTimeTracked ;

			// Les données stockées
			ProfilingInfosHolder _lastComputedInfos ;

			// Le callback à rappeler
			gpuAnswerCallback _doneCallback ;
			
		public :
		
			// Constructeur, destructeur
			ProfilingHelper () ;
			virtual ~ProfilingHelper () ;

			// Routines nécessaires
			virtual void preOperationRoutine () = 0 ;
			virtual void postOperationRoutine () = 0 ;

			// Activation ou pas des fonctionnalités
			virtual void setGpuTimeProfilingActivated (bool value) ;
			virtual void setCpuTimeProfilingActivated (bool value) ;
			virtual void setStatisticsProfilingActivated (bool value) ;

			// Setters
			void setInfosCallback (gpuAnswerCallback value) ;

			// Getters
			ProfilingInfosHolder* getLastComputedInfos () ;
	} ;
}