﻿//////////////////////////////////////////////
// DummyEnvironmentStrategy.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkScripts
#include "EnvironmentStrategy.h"

/// Class ------------------------------------

namespace nkScripts
{
	class DummyEnvironmentStrategy final : public EnvironmentStrategy
	{
		public :

			// Constructeur, destructeur
			DummyEnvironmentStrategy (Environment* parentEnv) ;
			~DummyEnvironmentStrategy () ;

			// Exécution
			virtual bool execute (const Script& script) override ;
			virtual void requestGarbageCollection () override ;
			virtual void shutdown () override ;

			// Set mémoire env
			virtual void setVar (const nkMemory::StringView& name, bool value) override ;
			virtual void setVar (const nkMemory::StringView& name, int value) override ;
			virtual void setVar (const nkMemory::StringView& name, float value) override ;
			virtual void setVar (const nkMemory::StringView& name, double value) override ;
			virtual void setVar (const nkMemory::StringView& name, const nkMemory::StringView& value) override ;
			virtual void setVar (const nkMemory::StringView& name, const ScriptObjectReference& value) override ;
			virtual void setObject (const nkMemory::StringView& name, const nkMemory::StringView& userType, void* value) override ;

			virtual bool isSet (const nkMemory::StringView& name) override ;

			virtual bool getVar (const nkMemory::StringView& name, bool defaultValue) override ;
			virtual int getVar (const nkMemory::StringView& name, int defaultValue) override ;
			virtual float getVar (const nkMemory::StringView& name, float defaultValue) override ;
			virtual double getVar (const nkMemory::StringView& name, double defaultValue) override ;
			virtual nkMemory::StringView getVar (const nkMemory::StringView& name, const nkMemory::StringView& defaultValue) override ;
			virtual ScriptObjectReference getVar (const nkMemory::StringView& name) override ;
			virtual void* getObject (const nkMemory::StringView& name, const nkMemory::StringView& userType) override ;
			virtual ScriptObjectReference getScriptFunction (const nkMemory::StringView& name) override ;

			// Functions
			virtual Function* setFunc (const nkMemory::StringView& name) override ;

			// UserTypes
			virtual UserType* setUserType (const nkMemory::StringView& name) override ;

			// Namespaces
			virtual Namespace* setNamespace (const nkMemory::StringView& name) override ;

			// Call C++ -> Script
			virtual bool callScriptFunction (const ScriptObjectReference& reference, const DataStack& args, DataStack& expectedOutput) override ;
			virtual nkMemory::Buffer serializeScriptObject (const ScriptObjectReference& reference, bool forwardUserDataOwnership) override ;
			virtual ScriptObjectReference deserializeScriptObject (const nkMemory::BufferView<unsigned char>& object) override ;
	} ;
}